/*
 * Copyright 2007-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.chronos.core.executor;

import java.util.concurrent.ExecutorService;

import org.seasar.chronos.core.ThreadPoolType;
import org.seasar.chronos.core.threadpool.ThreadPool;

/**
 * ExecutorServiceのファクトリクラスです．
 * 
 * @author j5ik2o
 * 
 */
public interface ExecutorServiceFactory {

    /**
     * ExecutorServiceを生成します．
     * 
     * @param type
     * @param threadPoolSize
     * @return
     */
    ExecutorService create(ThreadPoolType type, Integer threadPoolSize);

    ExecutorService create(ThreadPoolType type, Integer threadPoolSize,
            boolean daemon);

    ExecutorService create(ThreadPool threadPool);

    ExecutorService create(ThreadPool threadPool, boolean daemon);

    void shutdown();
}
