/*
 * Copyright 2007-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.chronos.core.task.state.impl;

import java.util.concurrent.TimeUnit;

import org.seasar.chronos.core.task.state.TaskExecuteContext;
import org.seasar.chronos.core.task.strategy.TaskExecuteStrategy;

public class TaskExecuteStateInitialized extends AbstractTaskExecuteState {

    public TaskExecuteStateInitialized(
            final TaskExecuteStrategy taskExecuteStrategy) {
        super(taskExecuteStrategy);
    }

    @Override
    public boolean await(final TaskExecuteContext context, final long time,
            final TimeUnit timeUnit) throws InterruptedException {
        return false;
    }

    @Override
    public void execute(final TaskExecuteContext context,
            final String startTaskName) throws InterruptedException {
    }

    @Override
    public boolean cancel(final TaskExecuteContext context) {
        return false;
    }

    @Override
    public String finish(final AbstractTaskExecuteContext context)
            throws InterruptedException {
        return null;
    }

    @Override
    public String start(final AbstractTaskExecuteContext context)
            throws InterruptedException {
        final String result = getTaskExecuteStrategy().start();
        changeState(context, context.getTaskExecuteStateStarted());
        return result;
    }

    @Override
    public void waitOne() throws InterruptedException {

    }

    @Override
    public void destroy(final AbstractTaskExecuteContext context) {

    }

    @Override
    public void initialize(final AbstractTaskExecuteContext context) {

    }

}
