package org.seasar.chronos.core.event;

import org.junit.runner.RunWith;
import org.seasar.chronos.core.Scheduler;
import org.seasar.chronos.core.SchedulerEventListener;
import org.seasar.chronos.core.TaskScheduleEntry;
import org.seasar.chronos.core.executor.ExecutorServiceFactory;
import org.seasar.chronos.core.impl.SchedulerImpl;
import org.seasar.chronos.core.impl.TaskStateType;
import org.seasar.chronos.core.schedule.ScheduleEntry;
import org.seasar.framework.unit.Seasar2;

@RunWith(Seasar2.class)
public class SchedulerEventHandlerTest implements SchedulerEventListener {

    private SchedulerEventHandler schedulerEventHandler = new SchedulerEventHandler();

    private ExecutorServiceFactory executorServiceFactory;

    public void addTaskScheduleEntry(final Scheduler scheduler,
            final TaskStateType taskStateType,
            final TaskScheduleEntry taskScheduleEntry) {
        System.out.println("addTaskScheduleEntry");
    }

    public void cancelTask(final Scheduler scheduler, final Object task) {
        System.out.println("cancelTask");
    }

    public void endScheduler(final Scheduler scheduler) {
        System.out.println("endScheduler");
    }

    public void endTask(final Scheduler scheduler, final Object task) {
        System.out.println("endTask");
    }

    public void pauseScheduler(final Scheduler scheduler) {
        System.out.println("pauseScheduler");
    }

    public void resumeScheduler(final Scheduler scheduler) {
        System.out.println("resumeScheduler");
    }

    public void removeTaskScheduleEntry(final Scheduler scheduler,
            final TaskStateType taskStateType,
            final TaskScheduleEntry taskScheduleEntry) {
        System.out.println("removeTaskScheduleEntry");
    }

    public void resigtTaskAfterScheduler(final Scheduler scheduler) {
        System.out.println("resigtTaskAfterScheduler");
    }

    public void resigtTaskBeforeScheduler(final Scheduler scheduler) {
        System.out.println("resigtTaskBeforeScheduler");
    }

    public void exceptionTask(final Scheduler scheduler, final Object task,
            final Exception e) {
        System.out.println("exceptionTask");
    }

    public void postBindFields() {
        schedulerEventHandler = new SchedulerEventHandler();
        schedulerEventHandler.setScheduler(new SchedulerImpl());
        schedulerEventHandler.add(this);
        schedulerEventHandler.setExecutorServiceFacotry(executorServiceFactory);
    }

    public void shutdownScheduler(final Scheduler scheduler) {
        System.out.println("shutdownScheduler");
    }

    public void startScheduler(final Scheduler scheduler) {
        System.out.println("startScheduler");
    }

    public void startTask(final Scheduler scheduler, final Object task) {
        System.out.println("startTask");
    }

    public void testFireAddTask() {
        final TaskScheduleEntry taskScheduleEntry = new ScheduleEntry();
        schedulerEventHandler.fireAddTaskScheduleEntry(TaskStateType.SCHEDULED,
                taskScheduleEntry);
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireCancelTask() {
        schedulerEventHandler.fireCancelTask(this);
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireEndScheduler() {
        schedulerEventHandler.fireEndScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireEndTask() {
        schedulerEventHandler.fireEndTask(this);
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFirePauseScheduler() {
        schedulerEventHandler.firePauseScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireRegistTaskAfterScheduler() {
        schedulerEventHandler.fireRegisterTaskAfterScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireRegistTaskBeforeScheduler() {
        schedulerEventHandler.fireRegisterTaskBeforeScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireShutdownScheduler() {
        schedulerEventHandler.fireShutdownScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireStartScheduler() {
        schedulerEventHandler.fireStartScheduler();
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireStartTask() {
        schedulerEventHandler.fireStartTask(this);
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

    public void testFireExceptionTask() {
        schedulerEventHandler.fireExceptionTask(this, new Exception());
        try {
            Thread.sleep(2000);
        } catch (final InterruptedException e) {
        }
    }

}
